Path = require 'path'

Chalk    = require 'chalk'
Inquirer = require 'inquirer'
Slugify  = require 'underscore.string/slugify'

module.exports = ->
  done = @async()
  prompts = []
  prompts.push
    type   : 'input'
    name   : 'module'
    message: 'Module name'
    validate: (str) ->
      if not str
        'Required field'
      else
        true

  prompts.push
    type   : 'input'
    name   : 'description'
    message: 'Description'
    validate: (str) ->
      if not str
        'Required field'
      else
        true

  prompts.push
    type   : 'input'
    name   : 'author'
    message: 'Author'
    store  : true
    validate: (str) ->
      if not str
        'Required field'
      else
        true

  prompts.push
    type   : 'input'
    name   : 'version'
    message: 'Version'
    default: '0.0.0'
    validate: (str) ->
      validVersion = str.match(/^(\d+\.)(\d+\.)(\d+)$/)
      if validVersion
        true
      else
        'Please enter a valid version number ( 0.0.0 )'

  prompts.push
    type:'list'
    name:'project'
    message:'Project'
    choices: [
      "runtime","sdk",new Inquirer.Separator(),"runtime-api","sdk-api"
    ]

  prompts.push
    type: 'confirm'
    name: 'es6'
    message: 'Would you like to use the es6 boilerplate?'
    when : (answers) ->
      return answers.project.indexOf('api') is -1

  @prompt prompts, ((answers) ->
    @LOCALS            = @LOCALS or {}
    @LOCALS            = answers
    @LOCALS.gitName    = @gitName
    @LOCALS.usesEs6    = @LOCALS.es6
    @LOCALS.module     = Slugify @LOCALS.module
    @LOCALS.moduleName = "g4-#{@LOCALS.project}-#{@LOCALS.module}"
    @LOCALS.pckName    = "@intelisis/g4-#{@LOCALS.project}-#{@LOCALS.module}"
    @LOCALS.path       = if @LOCALS.project.indexOf('api') > 0 then 'back' else 'front'
    @LOCALS.repo       = "https://github.com/IntelisisG4/#{@LOCALS.gitName}/#{@LOCALS.path}/#{@LOCALS.moduleName}"
    @LOCALS.githubUrl  = if @LOCALS.usesEs6 then "https://github.com/elgubenis/es6-module-boilerplate-browser/trunk" else "https://github.com/IntelisisG4/modules/trunk/npm-#{@LOCALS.path}end-boilerplate"
    done()
  ).bind(this)


