Path = require 'path'

Chalk  = require 'chalk'
Mkdirp = require 'mkdirp'

module.exports =
  makeModuleFolder: ->
    Mkdirp.sync(@LOCALS.moduleName)
    @destinationRoot(@LOCALS.moduleName)

  getRepo: ->
    done = @async()
    @spawnCommand('svn', ['export', @LOCALS.githubUrl, "templates"]).on 'close', ((data) ->
      @oldSourceRoot = @sourceRoot()
      @sourceRoot("templates")
      done()
    ).bind(this)

  bulk: ->
    @fs.copy @templatePath('**/*'), @destinationRoot()
    @fs.copy @templatePath('**/.*'), @destinationRoot()

  packageJSON: ->
    @sourceRoot @oldSourceRoot
    if @LOCALS.usesEs6
      @fs.copyTpl @templatePath("_es6package.json"), @destinationPath('package.json'), @LOCALS
    else
      @fs.copyTpl @templatePath("_#{@LOCALS.path}package.json"), @destinationPath('package.json'), @LOCALS

  readme: ->
    @fs.copyTpl @templatePath("_README.md"), @destinationPath('README.md'), @LOCALS

  publish: ->
    if @LOCALS.usesEs6
      @fs.copyTpl @templatePath("publish"), @destinationPath('publish'), @LOCALS



